#code 0xC0f0
#data 0xc000

#include <startup.c>
#include <68hc11.h>
#include <stdio.h>

#define  REG_BASE 0x1000

int temp;
int period;
unsigned int duty1;
 int duty2;
 int one_percent_per;
int d1, d2;

/***************************/
interrupt toc1(){
	
	
	temp = peek(REG_BASE + TOC3);
	temp = temp + period;
	poke(REG_BASE + TOC3, temp);
	
	temp = peek(REG_BASE + TOC2);
	temp = temp + period;
	poke(REG_BASE + TOC2, temp);

	temp = peek(REG_BASE + TOC1);
	temp = temp + period;
	poke(REG_BASE + TOC1, temp);

	bit_set(REG_BASE + TCTL1, 0x80); /* clear OC1 flag */
}


/***************************/

cal_offset(duty) int duty;{

	if (duty <= 50){
		temp = 100 - duty;
		return(one_percent_per * temp);
	}
	else{
		if (duty > 100){
			return (100 * one_percent_per);
		}
		else{
			return (duty * one_percent_per);
		}
	}
}


/***************************/
initialize(){
	
	bit_set(REG_BASE+TCTL1,0x50); /* OC2 and OC3 for toggle */
	pokeb(REG_BASE+TFLG1,0x80); /* clear OC1 flag */
	pokeb(REG_BASE+TMSK1,0x80); /* enable OC1 int. */
	pokeb(REG_BASE+OC1M, 0x60); /* OCM 6,5 = 1 */
	pokeb(REG_BASE + OC1D, 0x0);

	if (duty1 >= 50){
		bit_set(REG_BASE + OC1D, 0x40);
	}
	if (duty2 >= 50)
		bit_set(REG_BASE + OC1D, 0x20);
	period = (one_percent_per * 100);
	poke(REG_BASE+TOC1, period); /* schedule first OC1 compare */
	
	  temp = cal_offset(d1); printdec(temp);
	  poke(REG_BASE+TOC2, temp);
	  temp = cal_offset(duty2); printdec(temp);
	  poke(REG_BASE+TOC3, temp);
	
}


main(){
 
 poke(0xE0,toc1);   /* store addr of toc1 to pseudo int. vector */

 one_percent_per = 255;
 duty1 = 50;
 duty2 = 50;

 initialize();
 e_int();
 
 while(1){
	;
	
 }
}/*   */
/*  SMALL C COMPILER  */
/*  SYSTEM LIBRARY FOR THE 'HC11 */
/*   */


#asm
ARG1   EQU 6
ARG2   EQU 8
#endasm

/* NOTE: CCARGC MUST BE PASSED THE NUMBER OF BYTES OF LOCAL (STACK) */
/*       STORAGE FROM THE CALLING ROUTINE                           */
/* EX:   sort_lst(argc)int *argc;{                                  */
/*	  char maxlen;                                              */
/*	  char day;                                                 */
/*	  char numargs;                                             */
/*	  int  year;                                                */
/*	  numargs=CCARGC(1+1+1+2); /*note the param=number of local bytes */

CCARGC(n)int n;{
#asm
      PSHX
      PULA
      PULB
#endasm
}

/* Enable interrupts */
e_int(){
#asm
      CLI
#endasm
}

/* Disable interrupts */
d_int(){
#asm
      SEI
#endasm
}

/* Called with 1's in the position to be set */
bit_set(addr,val)
int addr;
char val;{
#asm
      LDX  ARG2,Y
      LDAB ARG1+1,Y
      ORAB 0,X
      STAB 0,X
#endasm
}


/* Called with 1's in the position to be cleared */
bit_clr(addr,val)
int addr;
char val;{
#asm
      LDX  ARG2,Y
      LDAB ARG1+1,Y
      COMB
      ANDB 0,X
      STAB 0,X
#endasm
}



pokeb(addr,val)
unsigned int addr;
unsigned char val;{
#asm
      LDX  ARG2,Y
      LDAB ARG1+1,Y
      STAB 0,X
#endasm
}

poke(addr,val)
unsigned int addr;
int val;{
#asm
      LDX ARG2,Y
      LDD ARG1,Y
      STD 0,X
#endasm
}

peekb(addr)
unsigned int addr;{
#asm
      LDX  ARG1,Y
      CLRA
      LDAB 0,X
#endasm
}

peek(addr)
unsigned int addr;{
#asm
      LDX ARG1,Y
      LDD 0,X
#endasm
}


print_ms(){
#asm
	LDX	#MSGMS
	JSR	.OUTSTO
#endasm
}
newline(){
#asm
	JSR  	.OUTCRL
#endasm
}

space(){
#asm
	LDX	#MSGSPCE
	JSR	.OUTSTO
#endasm
}

printdec(num) int num;{
#asm

	LDX	ARG1,Y		* get number
	LDY	#5		* num of digits
	LDX	#10
decdvlp IDIV			* least significant digit in B
	PSHB			* save it
	LDD	#10
	XGDX
	DEY
	BNE	decdvlp
*
* have five digs saved on stack; start printing when not zero
	LDAB	#5		* num digs to output
decoutlp	PULA
	ADDA	#'0'
	JSR	.OUTA
	DECB
	BNE	decoutlp
*
*	LDAA	#CR
*	JSR	.OUTA
*	LDAA	#LF
*	JSR	.OUTA
#endasm

}


delay(ms) int ms;{/*Uses OC5 to do delay; OC5 not available if
			delay(ms) is used
		    NOTE: Must enable interrupt before calling delay*/

#asm
	
	LDX	ARG1,Y	* time (ms) to delay
	LDY	#BASE	Point to register block
*	LDAA	#$08
	BCLR	TFLG1,Y	$F7Clear any pending OC5F flag


LOOP	CPX	#0
	BEQ	DONE

	LDD	TCNT,Y	Get current timer count
	ADDD	#2000	What will count be in 1mS?
	STD	TI4O5,Y Set OC5 to trigger then
LP1	BRCLR	TFLG1,Y $08 LP1	Loop here till OC5F=1

	BCLR	TFLG1,Y $F7	Clear OC5F
	DEX
	BNE	LOOP	Continue to delay
DONE	

#endasm
}


#asm
*************************************************
***    START OF LOW LEVEL LIBRARY ROUTINES   ****
***    PARTS BORROWED FROM MOTOROLA, OTHERS  ****
***    RE-WRITTEN BY MATT TAYLOR             ****
*************************************************

********
* MUL12
__MUL12
      PSHX
      PSHX
      PSHB
      PSHA
      TSX
      LDAA 3,X
      MUL
      STD  4,X
      LDD  1,X
      MUL
      ADDB 4,X
      STAB 4,X
      LDAB 3,X
      MUL
      ADDB 4,X
      STAB 4,X
      PULX
      PULX
      PULA
      PULB
      RTS

********
* ASR12
__ASR12
      XGDX
__ASRLOOP
      CPX  #0
      BEQ  __ASRDONE
      ASRA
      RORB
      DEX
      BRA  __ASRLOOP
__ASRDONE
      RTS

********
* ASL12
__ASL12
      XGDX
__ASLLOOP
      CPX  #0
      BEQ  __ASLDONE
      ASLD
      DEX
      BRA  __ASLLOOP
__ASLDONE
      RTS

********
*  __GE
__GE
      PSHX
      CPD  0,X
      BLT  __TRUE
      BRA  __FALSE

********
* __UGE
__UGE
      PSHX
      TSX
      CPD  0,X
      BLO  __TRUE
      BRA  __FALSE

********
* __GT
__GT
      PSHX
      TSX
      CPD  0,X
      BLE  __TRUE
      BRA  __FALSE

********
* __UGT
__UGT
      PSHX
      TSX
      CPD  0,X
      BLS  __TRUE
      BRA  __FALSE

********
* __LE
__LE
      PSHX
      TSX
      CPD  0,X
      BGT  __TRUE
      BRA  __FALSE

********
* __ULE
__ULE
      PSHX
      TSX
      CPD  0,X
      BHI  __TRUE
      BRA  __FALSE

********
* __LNEG
__LNEG
      PSHX
      CPD  #0
      BNE  __FALSE
      BRA  __TRUE

********
* __LT
__LT
      PSHX
      TSX
      CPD  0,X
      BGE  __TRUE
      BRA  __FALSE

********
* __ULT
__ULT
      PSHX
      TSX
      CPD  0,X
      BHS  __TRUE
      BRA  __FALSE

********
* __EQ
__EQ
      PSHX
      TSX
      CPD  0,X
      BEQ  __TRUE
      BRA  __FALSE

********
* __NE
__NE
      PSHX
      TSX
      CPD  0,X
      BNE  __TRUE
      BRA  __FALSE

********
*__TRUE
__TRUE
      PULX
      LDD  #1
      RTS

********
*__FALSE
__FALSE
      PULX
      LDD  #0
      RTS

********
* __SWITCH

__SWITCH
      PULX
__XLOOP
      PSHX
      LDX  0,X
      CPX  #0
      PULX
      BEQ  __XDEFAULT
      CPD  2,X
      BEQ  __XMATCH
      INX
      INX
      INX
      INX
      BRA  __XLOOP
__XDEFAULT
      INX
      INX
      JMP  0,X
__XMATCH
      LDX  0,X
      JMP  0,X

CR	EQU	$0D
LF	EQU	$0A

BASE	EQU	$1000
*
PORTA	EQU	$1000	* Port A data register
RESV1	EQU	$1001	* Reserved
PIOC	EQU	$1002	* Parallel I/O Control register
PORTC	EQU	$1003	* Port C latched data register
PORTB	EQU	$1004	* Port B data register
PORTCL	EQU	$1005	*
DDRC	EQU	$1007	* Data Direction register for port C
PORTD	EQU	$1008	* Port D data register
DDRD	EQU	$1009	* Data Direction register for port D
PORTE	EQU	$100A	* Port E data register
CFORC	EQU	$100B	* Timer Compare Force Register
OC1M	EQU	$100C	* Output Compare 1 Mask register
OC1D	EQU	$100D	* Output Compare 1 Data register
*
* Two-Byte Registers (High,Low -- Use Load & Store Double to access)
TCNT	EQU	$0E   * Timer Count Register
TIC1	EQU	$10   * Timer Input Capture register 1
TIC2	EQU	$12   * Timer Input Capture register 2
TIC3	EQU	$14   * Timer Input Capture register 3
TOC1	EQU	$16   * Timer Output Compare register 1
TOC2	EQU	$18   * Timer Output Compare register 2
TOC3	EQU	$1A   * Timer Output Compare register 3
TOC4	EQU	$1C   * Timer Output Compare register 4
TI4O5	EQU	$1E   * Timer Input compare 4 or Output compare 5 register
*
TCTL1	EQU	$20   * Timer Control register 1
TCTL2	EQU	$21   * Timer Control register 2
TMSK1	EQU	$22   * main Timer interrupt Mask register 1
TFLG1	EQU	$23   * main Timer interrupt Flag register 1
TMSK2	EQU	$24   * misc Timer interrupt Mask register 2
TFLG2	EQU	$25   * misc Timer interrupt Flag register 2
PACTL	EQU	$26   * Pulse Accumulator Control register
PACNT	EQU	$27   * Pulse Accumulator Count register
SPCR	EQU	$28   * SPI Control Register
SPSR	EQU	$29   * SPI Status Register
SPDR	EQU	$2A   * SPI Data Register
BAUD	EQU	$2B   * SCI Baud Rate Control Register
SCCR1	EQU	$2C   * SCI Control Register 1
SCCR2	EQU	$2D   * SCI Control Register 2
SCSR	EQU	$2E   * SCI Status Register
SCDR	EQU	$2F   * SCI Data Register
ADCTL	EQU	$30   * A/D Control/status Register
ADR1	EQU	$31   * A/D Result Register 1
ADR2	EQU	$32   * A/D Result Register 2
ADR3	EQU	$33   * A/D Result Register 3
ADR4	EQU	$34   * A/D Result Register 4
BPROT	EQU	$35   * Block Protect register
RESV2	EQU	$36   * Reserved
RESV3	EQU	$37   * Reserved
RESV4	EQU	$38   * Reserved
OPTION	EQU	$39   * system configuration Options
COPRST	EQU	$3A   * Arm/Reset COP timer circuitry
PPROG	EQU	$3B   * EEPROM Programming register
HPRIO	EQU	$3C   * Highest Priority Interrupt and misc.
INIT	EQU	$3D   * RAM and I/O Mapping Register
TEST1	EQU	$3E   * factory Test register
CONFIG	EQU	$3F   * Configuration Control Register
*
*
* Interrupt Vector locations
*
SCIINT	EQU	$D6	* SCI serial system
SPIINT	EQU	$D8	* SPI serial system
PAIINT EQU	$DA	* Pulse Accumulator Input Edge
PAOVINT EQU	$DC	* Pulse Accumulator Overflow
TOINT	EQU	$DE	* Timer Overflow
TOC5INT EQU	$E0	* Timer Output Compare 5
TOC4INT EQU	$E2	* Timer Output Compare 4
TOC3INT EQU	$E4	* Timer Output Compare 3
TOC2INT EQU	$E6	* Timer Output Compare 2
TOC1INT EQU	$E8	* Timer Output Compare 1
TIC3INT EQU	$EA	* Timer Input Capture 3
TIC2INT EQU	$EC	* Timer Input Capture 2
TIC1INT EQU	$EE	* Timer Input Capture 1
RTIINT	EQU	$F0	* Real Time Interrupt
IRQINT	EQU	$F2	* IRQ External Interrupt
XIRQINT EQU	$F4	* XIRQ External Interrupt
SWIINT	EQU	$F6	* Software Interrupt
BADOPINT EQU	$F8	* Illegal Opcode Trap Interrupt
NOCOPINT EQU	$FA	* COP Failure (Reset)
CMEINT	EQU	$FC	* COP Clock Monitor Fail (Reset)
RESETINT EQU	$FE	* RESET Interrupt
*
* Masks for serial port
PORTDWOM	EQU	$20
BAUD1200	EQU	$B3
BAUD9600	EQU	$B0
TRENA		EQU	$0C	* Transmit, Receive ENAble
.OUTA   EQU     $FFB8   Print character in A-reg
.OUTCRL EQU     $FFC4   Output <cr><lf>
.OUTSTO EQU     $FFCA   Output Msg seg (no <cr,lf>)
.OUTSTR EQU     $FFC7   Output Msg w/ leading <cr,lf>
PVOC2	EQU	$00DC	EVB Pseudo Vector for OC2


MSGSPCE	FCC	'        '
	FCB	$04	End-of-message mark
MSGMS	FCC	'  ms '
	FCB	$04	End-of-message mark
#endasm